
#include <windows.h>  
#include <commctrl.h>
#include "btnstate.h"  



#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName = "MyApp";
LPCTSTR lpszTitle   = "TB_GETSTATE"; 


BOOL RegisterWin95( CONST WNDCLASS* lpwc );


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon (hInstance, lpszAppName); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadImage(wcex.hInstance, lpwc->lpszClassName, 
                            IMAGE_ICON, 16, 16,
                            LR_DEFAULTCOLOR );
			
   return RegisterClassEx( &wcex );
}

// Toolbar buttons. 
//.................
TBBUTTON tbButtons[] = 
{ 
    { STD_FILENEW,  IDM_NEW, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0}, 
    { STD_FILEOPEN, IDM_OPEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0}, 
    { STD_FILESAVE, IDM_SAVE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0}, 
    { 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0L, 0}, 
    { VIEW_LARGEICONS, IDM_LARGEICON, TBSTATE_ENABLED, TBSTYLE_CHECKGROUP, 0, 0L, 0}, 
    { VIEW_SMALLICONS, IDM_SMALLICON, TBSTATE_ENABLED, TBSTYLE_CHECKGROUP, 0, 0L, 0}, 
    { VIEW_LIST, IDM_LISTVIEW, TBSTATE_ENABLED, TBSTYLE_CHECKGROUP, 0, 0L, 0}, 
    { VIEW_DETAILS, IDM_REPORTVIEW, TBSTATE_ENABLED, TBSTYLE_CHECKGROUP, 0, 0L, 0}, 
}; 


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
static HWND hToolWnd   = NULL;

   switch( uMsg )
   {
      case WM_CREATE :
              // Initialize the common control library
              // and create the status window and toolbar.
              //..........................................
              InitCommonControls();

              hToolWnd = CreateToolbarEx( hWnd, 
                                          WS_CHILD | WS_BORDER | WS_VISIBLE, 
                                          102, 
                                          11,
                                          (HINSTANCE)HINST_COMMCTRL, 
                                          IDB_STD_SMALL_COLOR, 
                                          tbButtons, 4,
                                          0, 0, 100, 30, sizeof(TBBUTTON) );

              if ( hToolWnd )
              {
                 TBADDBITMAP tb;
                 int index, stdidx;

                 // Add the system-defined view bitmaps.
                 //.....................................
                 tb.hInst = HINST_COMMCTRL;
                 tb.nID = IDB_VIEW_SMALL_COLOR;
                 stdidx = SendMessage(hToolWnd, TB_ADDBITMAP, 12, (LPARAM)&tb);
 
                 for (index = 4; index < 8; index++)
                    tbButtons[index].iBitmap += stdidx;
 
                 SendMessage(hToolWnd, TB_ADDBUTTONS, 4, (LONG) &tbButtons[4]);
              }
              break;

      case WM_INITMENUPOPUP :
              if ( LOWORD( lParam ) == 1 )
              {
                 UINT nCmd;

                 for ( nCmd = IDM_LARGEICON; nCmd <= IDM_REPORTVIEW; nCmd++ )
                 {
                    if ( SendMessage(hToolWnd, TB_GETSTATE, 
                                     nCmd, 0 ) & TBSTATE_CHECKED )
                    {
                       CheckMenuRadioItem((HMENU)wParam, IDM_LARGEICON,
                                                         IDM_REPORTVIEW,
                                                         nCmd,
                                                         MF_BYCOMMAND ); 
                    }
                 }
              }
              break;

      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_LARGEICON :
                 case IDM_SMALLICON :
                 case IDM_LISTVIEW :
                 case IDM_REPORTVIEW :
                        {
                           UINT nCmd;

                           if ( (SendMessage(hToolWnd, TB_GETSTATE, 
                                 LOWORD(wParam), 0 ) & TBSTATE_CHECKED) == 0 )
                           {
                              for( nCmd = IDM_LARGEICON; nCmd <= IDM_REPORTVIEW; nCmd++ )
                              {
                                 if ( nCmd == LOWORD(wParam) )
                                    SendMessage(hToolWnd, TB_SETSTATE, nCmd, 
                                                TBSTATE_CHECKED | TBSTATE_ENABLED); 
                                 else
                                    SendMessage(hToolWnd, TB_SETSTATE, nCmd, 
                                                TBSTATE_ENABLED); 

                              }
                           }
                        }
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
